const module_name  = "ByPic_bvserial"         'this name must be unique !!!
const module_ver   = "0.006"            'version
const PIPENAME = "bvserial_pipe"
dim fileName, scriptName

' ******************************************************************************
' new version to work with bvserial_16C, simplified script menu, mainly:
' 1 open file at cursor F5
' 2 send all F4
' 3 send selected SHIFT+F4
' ******************************************************************************

' ******************************************************************************
' C O M M O N
' ------------------------------------------------------------------------------
' sets focus to selecte program as script runs
' ------------------------------------------------------------------------------
Sub SetFocus
    CreateObject("WScript.Shell").AppActivate "bvserial"
End Sub

' ------------------------------------------------------------------------------
' sends text to bvserial which is listening on PIPNAME
' ------------------------------------------------------------------------------
Sub Pipe(s)
dim j
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set fout = fso.CreateTextFile("\\.\pipe\" & PIPENAME, True)
    fout.WriteLine(s)
End Sub


' ******************************************************************************
' C L I P B O A R D
' ------------------------------------------------------------------------------
' ------------------------------------------------------------------------------
' returns a list of file names separated by vbCrLf
' ------------------------------------------------------------------------------
' Sub OpenFiles
'     set obj = NewEditor()
'     obj.assignActiveEditor()
'     contents = obj.text()   ' text in current file
'     ' list of all files including current
'     for i = 0 to editorsCount() - 1
'         obj.assignEditorByIndex(i)
'         s = s + obj.fileName() & vbCrLf
'     next
' End sub

' sends all of the current editor, same as saving the file and sending that
' except the file does not need saving
' New format
' line 1 current file and path
' line 2 number of open files
' line 3..n  list of all open files including path
' line n - rest of current text
' ------------------------------------------------------------------------------
Sub SendAll
	dim s,i, contents
    SetFocus()
    set obj = NewEditor()

    obj.assignActiveEditor()
    contents = obj.text()   ' text in current file
    s = "All" & vbCrLf ' indicator for host
    s = s + obj.fileName() & vbCrLf ' current file
    s = s + CStr(editorsCount()) & vbCrLf ' number of open files
    ' list of all files including current
    for i = 0 to editorsCount() - 1
        obj.assignEditorByIndex(i)
        s = s + obj.fileName() & vbCrLf
    next
    obj.assignActiveEditor()
    s = s + "Start:::" ' start of text
    s = s + contents   ' text in current file
    setClipboardText(s) ' place in clipboard
    Pipe(".clip") ' instruction to bvserial
End Sub

' ------------------------------------------------------------------------------
' send selected text via the clipboard.
' line 1 "Selected"
' line 2 full path and file name
' line 3 Start:::<contents>
' ------------------------------------------------------------------------------
Sub SendSelected
	dim s
    SetFocus()
    set obj = NewEditor()
    obj.assignActiveEditor()
    s = "Selected" & vbCrLf ' indicator for host
    s = s + obj.fileName() & vbCrLf
    s = s + "Start:::" ' start of text
    s = s + obj.selText()   ' get selected text
    setClipboardText(s) ' place in clipboard
    Pipe(".clip") ' instruction to bvserial
End Sub

' ------------------------------------------------------------------------------
' attempts to open a file or URL at cursor
' ------------------------------------------------------------------------------
Sub OpenAtCursor
	dim line, start, fend, ftype
    ftype=0
    ' get line at cursor
    set obj = NewEditor()
    obj.assignActiveEditor()
    line = obj.lineText()

    ' see if http
    start = InStr(line,"http")
    if start <> 0 then
        ' extract just file
        fend = InStr(start,line," ")
        if start > fend then
            fname = Mid(line,start)
        else
            fname = Mid(line,start,fend-start)
        End if
        ftype = 1
    else
        ' if not http then has to be in ""
        start = Instr(line,"""")
        if start > 0 then
            fend = InStr(start+1,line,"""")
            if fend > start then
                fname = Mid(line,start,fend-start)
            End if
            ftype = 2
        End If
    End if

    ' remove any " at the ends
    if Len(fname) > 0 then
        fname = Trim(fname)
        q = InStr(fname,"""")
        if q = 1 then
            fname = Right(fname,Len(fname)-1)
        End if
        q = InStr(fname,"""")
        if q > 1 then
            fname = Left(fname,Len(fname)-1)
        End if
    End if

    ' do it
    if ftype = 1 then
        OpenURL(fname)
    End if
    if ftype = 2 then
        if FileExists(fname) <> 0 then
            obj.newFile(fname)
            obj.openFile(fname)
        else
            echo("Cant Find/open:"&fname)
        End if
    End if

End Sub

' ------------------------------------------------------------------------------
' send a command via the clipboard and get the results back
' send selected text via the clipboard.
' line 1 "Command"
' line 2 "text to send to device"
' ------------------------------------------------------------------------------
Function getCommandResult(cmd)
	dim s, rv
    rv="none"
    s = "Command" & vbCrLf ' indicator for host
    s = s + cmd & vbCrLf
    setClipboardText(s) ' place in clipboard
    Pipe(".clip") ' instruction to bvserial
'   Must wait for return values but cant use sleep as this not only blocks but stops
'   the whole thing from working, quick fix is to use the dialog below
    echo("ByPic.ini file updated" & vbCrLF & "changes will not be effective until editor is restarted")
    getCommandResult = getClipboardText()
End Function

' ******************************************************************************
' ******************************************************************************
Sub syntaxUpdate
    words7 = getCommandResult("list(3)")
    words = Replace(words7,"\r\n",vbCrLf)
    w1 = InStr(words,"-SYNTAX1-")
    w2 = InStr(words,"-SYNTAX2-")
    words1 = Mid(words,w1+11,(w2-6)-(w1+9))
    words2 = Mid(words,w2+11,Len(words)-(w2+17))
'echo("[" & words2 & "]" & w1 & "," & w2)
    ' rv is a two lists -SYNTAX1- and -SYNTAX2- these need to replace the ones in
    ' edit\Syntax\ByPic.INI
    mpath = modulePath() ' path the VB script
    fend = InStr(mpath,"Script") ' remove Script and add Syntax
    fname = Left(mpath,fend-1) & "Syntax\ByPic.INI"
    content = FileOpen(fname) ' contents of ByPic.INI
    p1 = InStr(content,"[KeyWords]")
    newContents = Left(content,p1-1) ' top bit of file now to add the new words
    newContents = newContents + "[KeyWords]" & vbCrLf
    newContents = newContents + words1  & vbCrLf
'echo("[" & newContents & "]")
    newContents = newContents + "[ReservedWords]"  & vbCrLf
    newContents = newContents + words2  & vbCrLf
    newContents = newContents + "[KeyWords2]"  & vbCrLf
    newContents = newContents + "[KeyWords3]"  & vbCrLf
    ' now save file
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set file = fso.OpenTextFile(fname, 2) ' 2 for writing
    file.Write(newContents)
    file.Close
End sub

' ******************************************************************************
' ******************************************************************************
Sub highlighterRestore
    mpath = modulePath() ' path the VB script
    fend = InStr(mpath,"Script") ' remove Script and add Syntax
    fname = Left(mpath,fend-1) & "Syntax\ByPicCopy.INI"
    if FileExists(fname) = 1 then
        content = FileOpen(fname) ' contents of ByPicCopy.INI
        fname = Left(mpath,fend-1) & "Syntax\ByPic.INI"
        ' now save file
        Set fso = CreateObject("Scripting.FileSystemObject")
        Set file = fso.OpenTextFile(fname, 2) ' 2 for writing
        file.Write(contents)
        file.Close
        echo("ByPicCopy.in copied to ByPic.ini" & vbCrLf & "changes will not take effect until editor is restarted")
    Else
        echo("Cannot find ByPic.ini in Syntax directory of the editor")
    End if
End sub

' ******************************************************************************
' F I L E
' ------------------------------------------------------------------------------
' ------------------------------------------------------------------------------
' returns 1 if file exists
' ------------------------------------------------------------------------------
Function  FileExists(name)
   Dim fso
   filespec=getVarValue("%MX150rookie%") 'getVarValue(%MX150rookie%) '"..\..\ASCII.ini"
   Set fso = CreateObject("Scripting.FileSystemObject")
   If (fso.FileExists(name)) Then
      FileExists = 1
   Else
      FileExists = 0
   End If
End Function

' ------------------------------------------------------------------------------
' Opend a file
' ------------------------------------------------------------------------------
Function  FileOpen(name)
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set file = fso.OpenTextFile(name, 1)
    content = file.ReadAll
    file.Close
    FileOpen = content
End Function

' ------------------------------------------------------------------------------
' Save file
' ------------------------------------------------------------------------------
Sub  FileSave(name, content)
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set file = fso.OpenTextFile(name, 1)
    file.Write(content)
    file.Close
End Sub

' ------------------------------------------------------------------------------
' Upens URL in new edit window
' removed ok cancel box
' ------------------------------------------------------------------------------
Sub OpenURL(url)
    Set req = CreateObject("Msxml2.XMLHttp.6.0")
    req.open "GET", url, False
    req.send
    If req.Status = 200 Then
        Set fso = CreateObject("Scripting.FileSystemObject")
        fName = fso.GetFileName(url)
        Set editor = newEditor()
        editor.newFile(fName)
        editor.appendText(req.responseText)
    Else
        echo("Unable to open URL")
    End If
End Sub

Sub OpenURLClip
    OpenURL(getClipboardText())
End sub


Sub Test
      'fso.OpenTextFile("C:\main.txt", 2).Write req.responseText
      runPSPadAction "aSyntaxChange"
End Sub

' name "Init" is required, its called automatically during initialization to create menu items
sub Init
  addMenuItem "&1. Sends All","", "SendAll",  "F4"
  addMenuItem "&2. Send Selected ","", "SendSelected", "Shift+F4"
  addmenuItem "&3. Open file at cursor", "", "OpenAtCursor", "F8"
  addmenuItem "&4. Highlighter Update", "", "syntaxUpdate", ""
  addmenuItem "&5. Highlighter Restore", "", "highlighterRestore", ""
  addMenuItem "Open URL in Clip","", "OpenURLClip",  ""
'  addMenuItem "&4. Sends File","BvSerial", "SendFile",  ""
'  addMenuItem "&5. Sends Script File","BvSerial", "SendBVScript",  "Shift+Ctrl+F"
'  addMenuItem "&6. Sends byp","BvSerial", "SendCurrentBlock",  "F8"
'  addMenuItem "Test","", "Test",  ""
end sub
